<?php
Class Event{
    
    var $event_name;
    var $stage_number;
    var $stage_name;
	var $event_id;
	var $stage_date;
	var $file_starts;
	var $file_results;
	var $start_time;
	var $browser_refresh;
	var $show_bib_number;
	var $recently_finished_interval;
    
    function Event($eventid=null,$stagen=null){
		$this->event_id=$eventid;
		$this->stage_number=$stagen;
		$this->SetDefaultFiles();
    }
	
	function IsValid(){
		return $this->event_id && $this->stage_number;
	}
	
	function GetBinFilePath(){
		return $this->GetEventDir()."event.bin";
	}
	
	function GetClassesBinFilePath(){
		return $this->GetEventDir()."classes.bin";
	}
	
	function IsConfigured(){
		return file_exists($this->GetBinFilePath());
	}
	
	function LoadInfoFromPost(){
		foreach(get_object_vars($this) as $var=>$value){
			$this->$var = GetVarPassed($var);
		}
	}
	
	function SetDefaultFiles(){
		$this->file_starts = $this->GetEventDir()."starts.csv";
		$this->file_results = $this->GetEventDir()."results.csv";
	}
	
	
	
	function GetEventDir(){
		return "server/events/$this->event_id.$this->stage_number/";
	}
	
	function ShowBibNumber(){
		return $this->show_bib_number=="on";
	}
	
	function GetRecentlyFinishedMinutes(){
		if ($this->recently_finished_interval) return $this->recently_finished_interval;
		else return _INTERVAL_TIME_NEW_MINUTES;
	}
	
	function LoadSettingsFromFile(){
		if (!file_exists(_CLIENT_EVENT_CONFIG_FILE)){
			die("Config file ("._CLIENT_EVENT_CONFIG_FILE.") not found. See manual at http://www.orioasis.pt/oasis/doc/index.php?page=liveores");
		}else{
			Add2Log("Loading event information from "._CLIENT_EVENT_CONFIG_FILE);
			$config = array_map("trim",explode(PHP_EOL,file_get_contents(_CLIENT_EVENT_CONFIG_FILE)));
			$lines = array_filter($config,function($k) {return $k && substr($k,0,1)!="#";});
			
			foreach($lines as $line){				
	
				preg_match('/^\[((.)+)\]$/', $line, $matches);
				
				if ($matches[1]){					
					$var = $matches[1];
				}else{
					if($var){
						$var_name = strtolower(str_replace(" ","_",$var));
						if ($var_name){
							$this->$var_name=$line;
							Add2Log("Loading variable [$var_name]=".$line);
						}
						$var = "";
					}
					
				}				
			}
			
			$this->show_bib_number = strtolower($this->show_bib_number);

			
			$success = true;
			foreach(get_object_vars($this) as $var=>$value){
				if (!$this->$var){
					Add2Log("Event variable missing [$var]");
					$success=false;
				}
			}
		
			if ($success){
				Add2Log("Event information loaded with success from file "._CLIENT_EVENT_CONFIG_FILE);
				$shortcut_content = "[InternetShortcut]".PHP_EOL.
									 "URL="._LIVE_O_SERVER_POST_URL."?event=$this->event_id&stage=$this->stage_number";
				$shortcut_name="View Live O Results $this->event_name - $this->stage_name - $this->stage_date";
				file_put_contents("$shortcut_name.url",$shortcut_content);
				
				Add2Log("Open the shortcut \"$shortcut_name\" created just now in the client folder in order to open the web page with the Live O Results");
			}
			return $success;
		}		
	}	
    
}