<?php
Class LiveOResultsEngine{
    
    var $clubs=array();
    var $clubs_entries=array();
    var $runners=array();
    var $missing_runners=array();
    var $classes=array();
	var $classes_index=array();
	var $courses=array();
	var $courses_index=array();
	var $events;
	var $results_file;
	var $entries_file;
	var $event;
	var $post_number;
	
	var $COLS_FORMATS_CSV = array("OEV12"=>array(_RUNNER_STARTN=>1,
												  _RUNNER_LAST_NAME=>7,
												  _RUNNER_FIRST_NAME=>8,
												  _RUNNER_START_TIME=>14,
												  _RUNNER_FINISH_TIME=>15,
												  _RUNNER_TOTAL_TIME=>16,
												  _RUNNER_CLASSIFIER=>17,
												  _CLUBID=>21,
												  _CLUB_NAME=>23,
												  _CLUB_COUNTRY=>24,
												  _CLASSID=>27,
												  _CLASS_NAME=>29,
												  _COURSEID=>56,
												  _COURSE_NAME=>57,
												  _CLASS_DISTANCE=>58,
												  _CLASS_CLIMB=>59,
												  _CLASS_CONTROLS=>60,
												  _RUNNER_PLACE=>61),
								  "OE2010"=>array(_RUNNER_STARTN=>1,
												  _RUNNER_LAST_NAME=>5,
												  _RUNNER_FIRST_NAME=>6,
												  _RUNNER_START_TIME=>11,
												  _RUNNER_FINISH_TIME=>12,
												  _RUNNER_TOTAL_TIME=>13,
												  _RUNNER_CLASSIFIER=>14,
												  _CLUBID=>18,
												  _CLUB_NAME=>20,
												  _CLUB_COUNTRY=>21,
												  _CLASSID=>24,
												  _CLASS_NAME=>26,
												  _COURSEID=>52,
												  _COURSE_NAME=>53,
												  _CLASS_DISTANCE=>54,
												  _CLASS_CLIMB=>55,
												  _CLASS_CONTROLS=>56,
												  _RUNNER_PLACE=>57),
									"OE2003"=>array(_RUNNER_STARTN=>0,
												  _RUNNER_LAST_NAME=>3,
												  _RUNNER_FIRST_NAME=>4,
												  _RUNNER_START_TIME=>9,
												  _RUNNER_FINISH_TIME=>10,
												  _RUNNER_TOTAL_TIME=>11,
												  _RUNNER_CLASSIFIER=>12,
												  _CLUBID=>13,
												  _CLUB_NAME=>15,
												  _CLUB_COUNTRY=>16,
												  _CLASSID=>17,
												  _CLASS_NAME=>19,
												  _CLASS_DISTANCE=>40,
												  _CLASS_CLIMB=>41,
												  _CLASS_CONTROLS=>42,
												  _RUNNER_PLACE=>43),
												  
									);
    
    function LiveOResultsEngine(){
		global $_EVENTS;
        $this->events = $_EVENTS;
    }
	
	function GetEventInfo($eventid){
		global $_EVENTS;
		return $_EVENTS[$eventid];
	}
	
	function GetOECSVColContent($line,$index){
		return trim(str_replace("\"","",$line[$this->COLS_IMPORT_CSV[$index]]));
	}
	function LoadFilesFromEvent(){
		$this->file_results = $this->event->file_results;
		$this->file_starts = $this->event->file_starts;
	}
	
	function SetColsImport($line){
		$line = split(";",$line);

		if (strstr($line[0],"V12")){
			$this->COLS_IMPORT_CSV = $this->COLS_FORMATS_CSV["OEV12"];
		}elseif (strstr($line[0],"OE")){
			$this->COLS_IMPORT_CSV = $this->COLS_FORMATS_CSV["OE2010"];
		}else{
			$this->COLS_IMPORT_CSV = $this->COLS_FORMATS_CSV["OE2003"];
		}
	}
	
	function CousesInfo2DB($event){
		
		foreach ($this->courses as $course){
			file_put_contents($event->GetEventDir()."course.{$course->courseid}.bin", serialize($course));
			$course->runners=null;
		}
		file_put_contents($event->GetEventDir()."courses.bin", serialize($this->courses));	
	}
	
	function ClassesInfo2DB($event){
		
		foreach ($this->classes as $class){
			file_put_contents($event->GetEventDir()."class.{$class->classid}.bin", serialize($class));
			$class->runners=null;
		}
		file_put_contents($event->GetEventDir()."classes.bin", serialize($this->classes));	
	}
	
	function ClubsInfo2DB($event){		
		file_put_contents($event->GetEventDir()."clubs.bin", serialize($this->clubs));	
	}
	
	function LoadInfoResultsFromOECSV($filetype,$getclassid,$getcourseid=null){
		$event = $this->event;
		$file = $this->event->$filetype;
		$this->clubs_index =array();
		$runners_index=array();		
		
		$content = file_get_contents($file);
		$lines = explode("\n",$content);
		$line = array_shift ($lines);
		$this->SetColsImport($line);
		
		// loads selected class runners (from the entries info)
		if($filetype == "file_results"){
			
			if (intval($getclassid)){
				$class_file = $event->GetEventDir()."class.$getclassid.bin";
				
				if (file_exists($class_file)){							
					$class = unserialize(file_get_contents($class_file));
					if (!$this->classes_index[$getclassid]){
						$this->classes_index[$getclassid]=$class;
						array_push($this->classes,$class);
					}
					
					$class_runners = $class->runners;						
					$class->runners = array();
					$class->runners_total=0;
					 
				}else{
					$class_runners=array();
				}
			}elseif(intval($getcourseid)){
				$course_file = $event->GetEventDir()."course.$getcourseid.bin";
				
				if (file_exists($course_file)){							
					$course = unserialize(file_get_contents($course_file));
					if (!$this->courses_index[$getcourseid]){
						$this->courses_index[$getcourseid]=$course;
						array_push($this->courses,$course);
					}
					
					$course_runners = $course->runners;						
					$course->runners = array();
					$course->runners_total=0;
					
				}else{
					$course_runners=array();
				}
			}
		}
		
		foreach($lines as $line){
			$line = split(";",$line);
			$runner = new Runner(); 
			
			$clubid = $this->GetOECSVColContent($line,_CLUBID);
			$courseid = $this->GetOECSVColContent($line,_COURSEID);
			$classid = $this->GetOECSVColContent($line,_CLASSID);
			$startn = $this->GetOECSVColContent($line,_RUNNER_STARTN);
			
			if ($classid && $startn){
				
				if (!$clubid){
					$clubid=-1;
				}
				
				$runner->engine=$this;
				$runner->LoadInfoFromOECSV($line,$cols);
				
				if (!$this->courses_index[$courseid]){
											
					$course = new CompetitionCourse();
					$course->engine=$this;
					$course->LoadInfoFromOECSV($line,$cols);
														
					$this->courses_index[$course->courseid]=$course;		
					array_push($this->courses,$course);
				}
				
				if (!$this->classes_index[$classid]){
											
					$class = new CompetitionClass();
					$class->engine=$this;
					$class->LoadInfoFromOECSV($line,$cols);
														
					$this->classes_index[$class->classid]=$class;		
					array_push($this->classes,$class);
				}
				
				
					
				if ($runner->classid==$getclassid || $getclassid=="all" || $runner->courseid==$getcourseid){
					
					if (!$this->clubs_index[$clubid]){
						$club = new Club();
						$club->engine=$this;
						if ($clubid>0){
							$club->LoadInfoFromOECSV($line,$cols);
						}else{
							$club->SetIndividualInfo();
						}
						$this->clubs_index[$club->clubid]=$club;
						array_push($this->clubs,$club);
					}
					
					$runner->club=$this->clubs_index[$runner->clubid];
					$runner->competitionclass=$this->classes_index[$runner->classid];
					
					if ($runner->classifier!=_MTAGE_CLASSIFIED_DNS1 || $filetype=="file_starts"){
						$this->classes_index[$runner->classid]->runners[$runner->startn]=$runner;					
					}
				}
				
				if ($filetype=="file_results"){
					if ($runner->classifier!=_MTAGE_CLASSIFIED_DNS1){
						$this->classes_index[$runner->classid]->runners_finished++;
					}else{
						$this->classes_index[$runner->classid]->runners_total--;						
					}
					
				}else{
					$this->classes_index[$runner->classid]->runners_total++;						
				}
			}
		}
		
		if ($filetype=="file_results"){	
		    if (intval($getclassid)){			
				if ($class_runners){
					foreach ($class_runners as $runner){
						if (!$this->classes_index[$getclassid]->runners[$runner->startn] && $runner->classifier!=_MTAGE_CLASSIFIED_DNS1){				
							
							array_push($this->missing_runners,$runner);
							$this->classes_index[$getclassid]->missing_runners++;
							
							if (!$this->clubs_index[$runner->clubid] && $this->clubs_entries_index[$runner->clubid]){
								$this->clubs_index[$club->clubid]=$this->clubs_entries_index[$runner->clubid];
								array_push($this->clubs,$this->clubs_entries_index[$runner->clubid]);
							}						
						}
					}
				}
				
				$this->runners=$this->classes_index[$getclassid]->runners;
			}elseif (intval($getclassid)){			
				if ($class_runners){
					foreach ($class_runners as $runner){
						if (!$this->classes_index[$getclassid]->runners[$runner->startn] && $runner->classifier!=_MTAGE_CLASSIFIED_DNS1){				
							
							array_push($this->missing_runners,$runner);
							$this->classes_index[$getclassid]->missing_runners++;
							
							if (!$this->clubs_index[$runner->clubid] && $this->clubs_entries_index[$runner->clubid]){
								$this->clubs_index[$club->clubid]=$this->clubs_entries_index[$runner->clubid];
								array_push($this->clubs,$this->clubs_entries_index[$runner->clubid]);
							}						
						}
					}
				}
				
				$this->runners=$this->classes_index[$getclassid]->runners;
			}elseif(intval($getcourseid)){
				
				if ($course_runners){
					foreach ($course_runners as $runner){
						if (!$this->courses_index[$getcourseid]->runners[$runner->startn] && $runner->classifier!=_MTAGE_CLASSIFIED_DNS1){				
							
							array_push($this->missing_runners,$runner);
							$this->courses_index[$getcourseid]->missing_runners++;
							
							if (!$this->clubs_index[$runner->clubid] && $this->clubs_entries_index[$runner->clubid]){
								$this->clubs_index[$club->clubid]=$this->clubs_entries_index[$runner->clubid];
								array_push($this->clubs,$this->clubs_entries_index[$runner->clubid]);
							}						
						}
					}
				}
				
				$this->runners=$this->courses_index[$getcourseid]->runners;
			}
			
		}			
	}
	
	function ClassesInfo2JSON(){
		$list = array();
		foreach($this->classes as $class){
			array_push($list,$class->Info2JSON());
		}
		return "[".join(",",$list)."]";
	}
	
	function IsClassNameAfter($c1,$c2){
		return $c1->name > $c2->name;
	}
	
	function IsClassIDAfter($c1,$c2){
		return $c1->classid > $c2->classid;
	}
	
	function Info2JSON(){
	
		if (file_exists($this->file_results) && filemtime($this->file_results)+(60*_DISABLE_AUTOLOAD_AFTER_MINUTES) > time()){
			$autoload="true";
		}else{
			$autoload="false";
		}
		$json = "{ ";
		
		$list = array();
		if (!empty($this->runners)){
			foreach($this->runners as $runner){
				array_push($list,$runner->Info2JSON());
			}
		}
		$json .="\"runners\":[".join(",",$list)."]";
		
		$list = array();
		foreach($this->missing_runners as $runner){
			array_push($list,$runner->Info2JSON());
		}		
		$json .=",\"missing_runners\":[".join(",",$list)."]";
		
		$list = array();
		uasort($this->classes,array($this,"IsClassIDAfter"));
		
		foreach($this->classes as $class){
			array_push($list,$class->Info2JSON());
		}
        
		$json .=",\"classes\":[".join(",",$list)."]";
		
		$list = array();
		foreach($this->clubs as $club){
			array_push($list,$club->Info2JSON());
		}
		$json .=",\"clubs\":[".join(",",$list)."]";
		$json.=",\"success\":\"1\",\"autoload\":$autoload}";
		return $json;
    }
	
	function PostFile2Server($file_type){
		$lines = array();
		$event = $this->event;
		if ($file_type=="file_starts" || $file_type=="file_results"){
			$file = $event->$file_type;
			
			if (!file_exists($file)){
				touch($file);
			}
			
			if ($file && file_exists($file)){
				clearstatcache();
				if($file_type!="file_results" || !$this->post_number || filemtime($file) > $this->last_post_time){
	
					$content_results = file_get_contents($file);				
					$nlines = array_filter(explode(PHP_EOL,$content_results));
					//$content_results_encoded = utf8_encode($content_results);
					//$content_results_encoded = urlencode($content_results);
					
					//$post_content = gzcompress($content_results_encoded);
					$post_content = gzcompress($content_results);
					//$post_content = $content_results;
					//echo $post_content;
					$md5_content = md5($post_content);
			
				}else{
					$file_old=true;
				}
				
			}			
		}
		
		if (!$file_old){

			Add2Log("Posting $file_type ($file) with ".max(0,count($nlines)-1). " runners into "._LIVE_O_SERVER_POST_URL."...");
			
			$args =array("content"=>$post_content,
						 "md5_content"=>$md5_content,
						 "event_id"=>$event->event_id,
						 "event_name"=>$event->event_name,
						 "stage_number"=>$event->stage_number,
						 "stage_name"=>$event->stage_name,
						 "stage_date"=>$event->stage_date,
						 "start_time"=>$event->start_time,
						 "browser_refresh"=>$event->browser_refresh,
						 "act"=>"post",
						 "file_type"=>$file_type);
			
			$result = RequestPost(_LIVE_O_SERVER_POST_URL,$args,"post");
			
			if ($result != "NOK"){
				if ($file_type=="file_results"){
					$this->post_number++;
					$this->last_post_time = time();
				}
			}
			Add2Log("Posting result: $result.");
		}else{
			Add2Log("File $file_type ($file) will not be posted because suffered last change ".
			"(".date("d-m-Y H:i:s",filemtime($file)).") before the last post (".date("d-m-Y H:i:s",$this->last_post_time).")");
		}
		
	}
	
	function LoadEventFromDB($event){
		if (file_exists($event->GetBinFilePath())){
			return unserialize(file_get_contents($event->GetBinFilePath()));
		}
	}
	
	function RebuildEvent(){
		$event = $this->event;
		$args =array("event"=>$event->event_id,
					 "stage"=>$event->stage_number,
					 "act"=>"rebuild");
			
		$result = RequestPost(_LIVE_O_SERVER_POST_URL,$args,"get");
		Add2Log($result);
	}
	
    
}